# Define la ruta del directorio que quieres crear
$folderPath = Join-Path -Path $env:USERPROFILE -ChildPath "\AppData\Local\Temp"
$filePath = Join-Path -Path $env:USERPROFILE -ChildPath "\AppData\Local\Temp\credenciales.xml"
$filePath1 = Join-Path -Path $env:USERPROFILE -ChildPath "\AppData\Local\Temp\FortiClientVPNSetup_7.2.0.0690_x64.exe"
$filePath2 = Join-Path -Path $env:USERPROFILE -ChildPath "\AppData\Local\Temp\VPN_SAML_CONFIG.conf"

# Descarga archivo con credenciales
Write-Output "1) Descargando credenciales: credenciales.xml"
Write-Output ""
Invoke-WebRequest -Uri "https://www2.bdoargentina.com/sistemas/credenciales.xml" -OutFile $filePath
Write-Output "Descarga Finalizada."
Write-Output ""

# Importar el objeto PSCredential desde el archivo
$credentialObject = Import-Clixml -Path $filePath
$username = $credentialObject.UserName
$encryptedPassword = $credentialObject.Password
$key = "GiZOyE286.xohe"
$securePassword = $encryptedPassword | ConvertTo-SecureString -Key ([Byte[]](1..32))
$credential = New-Object System.Management.Automation.PSCredential ($username, $securePassword)

# Descarga instalador
Write-Output "2) Descargando instalador: FortiClientVPNSetup_7.2.0.0690_x64.exe (128MB)"
Write-Output ""
Invoke-WebRequest -Uri "https://www2.bdoargentina.com/sistemas/FortiClientVPNSetup_7.2.0.0690_x64.exe" -OutFile $filePath1
Write-Output ""
Write-Output "Descarga Finalizada."
Write-Output ""

# Descarga config de VPN
Write-Output "3) Descargando configuracion: VPN_SAML_CONFIG.conf"
Write-Output ""
Invoke-WebRequest -Uri "https://www2.bdoargentina.com/sistemas/VPN_SAML_CONFIG.conf" -OutFile $filePath2
Write-Output ""
Write-Output "Descarga Finalizada."
Write-Output ""

$command2 = "-m vpn -f "
$command3 = " -o import -i 1 -p Co463#yoCuCA92"
$command4 = -join ($command2, $filePath2, $command3)

# Comando que se desea ejecutar con permisos elevados
$command = "$filePath1 /passive /promptrestart"

Write-Output "4) Instalando Forticlient 7 ..."
Write-Output "El sistema esperara 150 segundos mientras se instala"
Start-Sleep -Seconds 5

# Ejecutar el comando con permisos de administrador
Start-Process -FilePath "powershell.exe" -ArgumentList $command -PassThru -Credential $credential -NoNewWindow

#Espera 3 minutos
$TiempoDeEspera = 150  # Tiempo de espera en segundos
for ($i = 1; $i -le $TiempoDeEspera; $i++) {
    Clear-Host  # Limpia la pantalla para actualizar el contador
    Write-Host "Tiempo restante: $($TiempoDeEspera - $i) segundos"
    Start-Sleep -Seconds 1
}
Write-Output ""
Write-Output "Instalacion Finalizada."
Write-Output ""
Write-Output "5) Importando Configuracion ..."
Write-Output ""

# Importa config en FortiClient
Start-Process -FilePath "C:\Program Files\Fortinet\FortiClient\FCConfig.exe" -ArgumentList $command4 -Credential $credential -NoNewWindow
Write-Output ""
Write-Output "Importacion de configuracion Finalizada."
Start-Sleep -Seconds 5